unit mainform;

{created by anonymous26}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls;

type
  Tsirkyform = class(TForm)
    pb1: TPaintBox;
    ngBtn: TButton;
    pl1Cp: TLabel;
    point1lbl: TLabel;
    pl2cp: TLabel;
    point2lbl: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure ngBtnClick(Sender: TObject);
    procedure paintsirky;
    procedure pb1Paint(Sender: TObject);
    procedure pb1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure putsirka(x,y,line:byte);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure paintdrawn;
    procedure addpoints;
  private
    { Private declarations }
    sirky : array[0..11,0..11] of byte;
    cellsize:byte;
    game,nowplayed,canchange:boolean;
    curplayer:byte;
    points1,points2:byte;
  public
    { Public declarations }
    size : byte;
    pl1,pl2:string;    {jmena}
  end;

var
  sirkyform: Tsirkyform;

implementation

{$R *.DFM}
 uses new,key;

procedure Tsirkyform.paintsirky;
{kresli mrizku}
var i:byte;
begin
 pb1.Canvas.Pen.Color:=clBlack;
 cellsize:=240div size;
 pb1.Height:=size*cellsize+1;
 pb1.Width:=pb1.Height+1;
 for i:=0to size do
  begin
   pb1.Canvas.moveto(i*cellsize,0);
   pb1.Canvas.Lineto(i*cellsize,pb1.Height-1);
  end;
 for i:=0to size do
  begin
   pb1.Canvas.moveto(0,i*cellsize);
   pb1.Canvas.Lineto(pb1.Height-1,i*cellsize);
  end
end;

procedure Tsirkyform.putsirka(x,y,line:byte);
{vykresleni sirky}
var a:byte;
    cando:boolean;
begin
 canchange:=false;
 pb1.canvas.pen.color:=clRed;
 a:=sirky[x+1,y+1];
 cando:=true;
 if a>=8then begin
  a:=a-8; if line = 8 then cando:=false;
 end;
 if a>=4then begin
  a:=a-4; if line = 4 then cando:=false;
 end;
 if a>=2then begin
  a:=a-2; if line = 2 then cando:=false;
 end;
 if a>=1then begin
  if line = 1 then cando:=false;
 end;
if (cando)or(not nowplayed) then
 begin
 canchange:=true;
 sirky[x+1,y+1]:=sirky[x+1,y+1]+line;
 case line of
  1:
   begin
    pb1.Canvas.Moveto(x*cellsize,y*cellsize);
    pb1.Canvas.lineto((x+1)*cellsize,y*cellsize);
    sirky[x+1,y]:=sirky[x+1,y]+4;
   end;
  2:
   begin
    pb1.Canvas.Moveto((x+1)*cellsize,y*cellsize);
    pb1.Canvas.lineto((x+1)*cellsize,(y+1)*cellsize);
    sirky[x+2,y+1]:=sirky[x+2,y+1]+8;
   end;
  4:
   begin
    pb1.Canvas.Moveto(x*cellsize,(y+1)*cellsize);
    pb1.Canvas.lineto((x+1)*cellsize,(y+1)*cellsize);
    sirky[x+1,y+2]:=sirky[x+1,y+2]+1;
   end;
  8:
   begin
    pb1.Canvas.Moveto(x*cellsize,y*cellsize);
    pb1.Canvas.lineto(x*cellsize,(y+1)*cellsize);
    sirky[x,y+1]:=sirky[x,y+1]+2;
   end;
 end;
 if sirky[x+1,y+1]=15then begin addpoints; sirky[x+1,y+1]:=16; end;
 if sirky[x,y+1]=15then begin addpoints; sirky[x,y+1]:=16; end;
 if sirky[x+1,y]=15then begin addpoints; sirky[x+1,y]:=16; end;
 if sirky[x+2,y+1]=15then begin addpoints; sirky[x+2,y+1]:=16; end;
 if sirky[x+1,y+2]=15then begin addpoints; sirky[x+1,y+2]:=16; end;
end;
end;

procedure Tsirkyform.addpoints;
{pridavani bodu}
var vict:boolean;
    i, j:byte;
    s:string;
begin
 if curplayer=1 then points1:=points1+1
                else points2:=points2+1;
  canchange:=false;
 vict:=true;
 for i:=1to 10 do
  for j:=1to 10 do
   if sirky[i,j]<>16 then vict:=false;
 if points1>points2 then s:=pl1;
 if points1<points2 then s:=pl2;
 if (points1=points2)and(vict) then ShowMessage('Remiza');
 if (vict)and(points1<>points2) then ShowMessage('Vyhral '+s);
end;

procedure Tsirkyform.paintdrawn;
var i, j,a,b: byte;
begin
 pb1.Canvas.Pen.Color:=clRed;
 nowplayed:=false;
 a:=curplayer;
 {curplayer:=0;}
 for i:=1 to size do
  for j:=1to size do
  begin
   b:=sirky[i,j];
   if b>=8 then
    begin
     b:=b-8; putsirka(i-1,j-1,8);
    end;
   if b>=4 then
    begin
     b:=b-4; putsirka(i-1,j-1,4);
    end;
   if b>=2 then
    begin
     b:=b-2; putsirka(i-1,j-1,2);
    end;
   if b>=1 then
    begin
     putsirka(i-1,j-1,1);
    end;
  end;
 curplayer:=a;
end;

procedure Tsirkyform.FormCreate(Sender: TObject);
begin
 size:=0;
 game:=false;
 curplayer:=1;
{}
end;

procedure Tsirkyform.ngBtnClick(Sender: TObject);
{nova hra}
var i,j : byte;
begin
 newform.Showmodal;
 game:=true;
 pl1cp.Caption:=pl1;
 pl2cp.Caption:=pl2;
 for i:=1 to 10 do
  for j:=1 to 10 do
   sirky[i,j]:=0;
end;

procedure Tsirkyform.pb1Paint(Sender: TObject);
{prekresleni}
begin
 if size<>0 then
  begin
   paintsirky;
   paintdrawn;
  end;
end;

procedure Tsirkyform.pb1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
{reakce na kliknuti do pole-zmeny hracu, urceni kreslene sirky}
var clickx,clicky,clicked:byte;
begin
 nowplayed:=true;
 clickx:=x div cellsize;
 clicky:=y div cellsize;
 if y>(clicky*cellsize+cellsize/2) then
  begin
   clicked:=4;
   if (cellsize- (y mod cellsize))>(x mod cellsize) then clicked:=8;
   if (cellsize- (x mod cellsize))<(cellsize-(y mod cellsize)) then clicked:=2;
  end
 else
  begin
   clicked:=1;
   if (x mod cellsize)<(y mod cellsize) then clicked:=8;
   if (cellsize- (x mod cellsize))<(y mod cellsize) then clicked:=2;
  end;
 putsirka(clickx, clicky,clicked);
 point1lbl.Caption:=inttostr(points1);
 point2lbl.Caption:=inttostr(points2);
 if canchange then
 if curplayer=1 then
  begin
   curplayer:=2;
   pl1cp.Enabled:=false;
   point1lbl.Enabled:=false;
   pl2cp.Enabled:=true;
   point2lbl.Enabled:=true;
  end
 else
  begin
   curplayer:=1;
   pl2cp.Enabled:=false;
   point2lbl.Enabled:=false;
   pl1cp.Enabled:=true;
   point1lbl.Enabled:=true;
  end;
end;

procedure Tsirkyform.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
{reakce na klavesnici-data je mozno zadavat po stisku insert
prece je vhodnejsi ovladat to mysi}
begin
 if (key=VK_INSERT)and(game) then keyform.showmodal;
end;

end.
